From 97c9203885e942220886120f9cfec9ea4e3f69d7 Mon Sep 17 00:00:00 2001
From: Alexey Minnekhanov <alexeymin@postmarketos.org>
Date: Sun, 20 Jun 2021 22:58:29 +0300
Subject: [PATCH 51/59] HACK: AlpineApkResource: Workaround broken Alpine
 metadata

thumbnails from Alpine metadata are unusable
---
 .../AlpineApkBackend/AlpineApkResource.cpp       | 16 +++++++++++++++-
 1 file changed, 15 insertions(+), 1 deletion(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp
index 459347061..d7ac49012 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkResource.cpp
@@ -220,7 +220,21 @@ void AlpineApkResource::fetchChangelog()
 void AlpineApkResource::fetchScreenshots()
 {
     if (hasAppStreamData()) {
-        const QPair<QList<QUrl>, QList<QUrl> > sc = AppStreamUtils::fetchScreenshots(m_appsC);
+        /*const*/ QPair<QList<QUrl>, QList<QUrl>> sc = AppStreamUtils::fetchScreenshots(m_appsC);
+        if (sc.first.size() > 0) {
+            const QUrl &url = sc.first.first();
+            if (url.isRelative()) {
+                // This is a hack to fix broken Alpine Linux appstream
+                // metadata: somehow generated thumbnails URLs are relative
+                // and always fail to load (not present in metadata at all)
+                // We work around this by using full url, which is veyr not
+                // good - they're fetched by http://...
+                // It would be great if thumbnails were hosted locally.
+                if (sc.second.size() > 0) {
+                    sc.first = sc.second;
+                }
+            }
+        }
         Q_EMIT screenshotsFetched(sc.first, sc.second);
     }
 }
-- 
GitLab


